/*
the class of ARG with fast format. 

id1 id2 start end


structure

edges[i]: edge information that connects to i
nc: number of children
c[i]:  id of child i
[st[i], ed[i]) : segment for child i
active   if this node is active


a marginal tree at (chr, pos) is a tree build from edges where
st[i] <= (chr, pos) < ed[i]
*/


#ifndef __CREADFARGs__
#define __CREADFARGs__
#include "stdlib.h"


#include "CTree_SamtoolLK.h"
#include "Const.h"


struct Edge{
  int nc; //number of child
  int c[2];
  int st[2];
  int ed[2];
  int active;
};



class CARG_f{
private:
  int* chr;
  int* pos;

  int  nleaf; //number of haplotypes = number of leaves 
  int  m;     //number of markers
  int  mne;   //maximum number of nodes
  int root;   //root of ARG
  int nsample; //number of sample = nleaf /2
  int exist;//exist data or not


  char *alnnames[MAXSAMPLE];

  Edge *edges;
  int MoveDown(int id, int mid)   ;
  void GetTree(int r, int mid, int*p, int &nn);

  int CountChildren(int id, int mid, int & sid);
  int Seek(int rchr, int rpos);

  CTree tree[2];
  int CheckTree(int *p, int nn, int rp); //rp: 0 (r, ch1, chr) rp =2 (ch1, ch2, r)

  void Display(int mid);
  int SAT (int i, int j, int mid);

  int index[MAXSAMPLE];

  double *logprob;

public:
  CARG_f();
  ~CARG_f();


  void Display(void);
  int GetTree(int mid, int *p);
  void BuildTree(int r, int mid, int*p, int &nn);


  void ReMap(int *p, int nn, int *t);

  void DisplayTree(int *p, int nn, int r, char *stree);                
  void DisplayTree(int *p, int nn, int r);
  void VertString2Array(char *st, int *t, int &nn);

  //  void Init(char *fnARG, int *fnSamples);
  int Init(char *fn, char *fnsample);
  


  void Init(int nedges, int nmarker,int chr, int *marker);

  void Add(int id1, int id2, int st, int ed);

  int GetTrees(int rchr, int rpos, CTree **T);
  int GetNumSamples(void);


  void Init(int rchr, int nmarker,  int *marker, int nsample, char ** rnames);


  int ExistData(void) { return exist;}

  char ** GetNames(void) { return alnnames;}
  int GetNsample(void) { return nsample;}

  void InitLikelihoodName(char ** lknames, int nslk);
  void InitLKData(double * rlogprob) { logprob = rlogprob;  }
  void SetExist(int x) { exist = x;}
};

#endif
