/*
read trees from Margarita format
*/

#ifndef __CLASS_ARG_M__
#define __CLASS_ARG_M__

#include <stdio.h>
#include "/nfs/users/nfs_p/pd3/cvs/tabix/bgzf.h"
#include "/nfs/users/nfs_p/pd3/cvs/tabix/tabix.h"


#include "CTree_SamtoolLK.h"
#include "Const.h"



class CARG_m
{

private:

  int bzgip; //using plain text tree files (0) or bgzip 
  int nleaf;

  CTree** Ts;
  int nt; // end of Ts
  int stntid;//start number tree id
  int maxtree;


  FILE *f; //read from plain text file

  BGZF *bgzipf; //read from bgzip file
  ti_index_t *bgzipf_id; //read from bgzip file


  int leafid[MAXSAMPLE*2];
  char* alnnames[MAXSAMPLE]; //name of alignments
  int nsp ; //number of samples in ARG trees

  int index[MAXSAMPLE];
  void Remove(int nrmt);

  //be very careful when using ReadNextTree because nt (the number of tree) would change
  //  void ReadNextTree(void);

  double * logprob; //pointer to the likelihood data
  //  static int AddTrees(int l, const char*s, void *data);


  int leftequal(int i); //find the left j, Ts[i] = Ts[j]


public:
  CARG_m();
  ~CARG_m();

  int Init(char* fnListSample, char *fnARG); //init trees from files, fnARG (tree), fnListSample, list of samples
  int Init(char* fnListSample, char *fnARG, int vbgzip);

  void NewTree(void);


  void ReadAlignName(char* fn);//read alignment names in fn
  int GetTrees(int chr, int pos, CTree** T);//if exist tree at(chr, pos) --> return trees at (chr, pos); Otherwise, //Get trees around (chr, pos). 

  int GetTrees(char *chr, int pos, CTree** T)
    {
      return GetTrees(atol(chr), pos, T);
    }

  CTree *GetTree(int id) { 
    if (id >= nt) return Ts[nt-1];
    else return Ts[id];
  }

  int Getnt(void) { return nt;}
  
  char ** GetNames(void) { return alnnames;}
  char * GetName(int i) { return alnnames[i];}

  int GetNumAlns(void) { return nsp; }
  int GetNsample(void) { return nsp;}

  void Display(void) { };

  //  void ReadNext(int chr, int pos);

  void InitLikelihoodName(char ** lknames, int nslk);
  void InitLKData(double *rlogprob) { logprob = rlogprob;}
  void Reset(void);


  int ReadNextTree(int nrt); //end of file 
  int GetTree(int id,  CTree **T);

  int ReadNextTree_bgzip(int rchr, int rpos);
};

#endif
