#ifndef __CCALL__
#define __CCALL__


#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "Const.h"
#include "CARG_m.h"
#include "CARG_f.h"
#include "CFastARG.h"
#include "CPhase.h"
#include "CDataLikelihood.h"
#include "CHaplotypes.h"
#include "CNoLinkageGen.h"




class CCall
{
 private:
  int blocksize;
  int inputtype;

  char argname_m[1024], samples_m[1024]; //name of ARG trees from Margarita, file of sample names
  char argname_f[1024], samples_f[1024]; //name of ARG trees from fast ARG,  file of sample names
  char fname[1024], fnout[1024];
  
  char * likelihoodFileNames[MAXSAMPLE];//
  char * ListSamples[MAXSAMPLE];



  double threshold;
  int chr, st, ed; //chr, start, end 
  int nlks; //number of likelihood file name
  int onego;

 public:
  CCall();
  ~CCall();

  void Call(void);
  
  void SetThreshold(double x);
  //  void SetFileNames(char *fn);

  void SetOutPut(char *fn);
  //  void SetChrStEd(int rchr, int rst, int red);

  void SetARG_M(char *i_argname, char *i_samples); 
  void SetARG_f(char *i_argname, char *i_samples); 

  //  void SetBlockSize(int blsize);

  //  void PutLikelihoodNames(char *s);
  //  void ReadLikelihoodNames(char *fn);

  void Filter(char ** names, int ns);
  int NotMatch(char **s1, char**s2, int ns1, int ns2);


  void SetOneGo(int x) { onego = x;}
};


#endif
