#include "CData4Phase.h"



CData4Phase::CData4Phase()
{
  data = NULL;
  nsite = 0;
  mnsite = 0;
}



CData4Phase::~CData4Phase()
{
  for (int i = 0; i != nsite; ++i) delete data[i];
  if (data != NULL) free(data);
}



void CData4Phase :: Add(COneSiteLK *os)
{
  if (nsite >= mnsite) {
    mnsite += 10000;
    data = (COneSiteLK**)realloc(data, mnsite * sizeof(COneSiteLK*));
  }
  data[nsite++] = os;
}


void CData4Phase :: Display(void)
{
  printf("nsite = %d\n", nsite);
  for (int i = 0; i != nsite; ++i) data[i]->Display();
}



CHap4ARG * CData4Phase::GetGen(void)
{
  CHap4ARG *Haps = new CHap4ARG;

  char *haps = (char*)calloc(nsn * 2 + 10, sizeof(char));
  for (int i = 0;  i != nsite; ++i)
    {
      if (data[i]->GetConf() < SNPCAN_TH) continue;
      data[i]->Genotype(haps);
      if (!Singleton(haps)) Haps->Add(data[i]->GetChrInt(), data[i]->GetPos(), haps);
    }
  free(haps);
  return Haps;
}




int CData4Phase :: Singleton(char *hap)
{
  int len = strlen(hap);
  int n0 = 0, n1 = 0;
  for (int i = 0;  i != len; ++i)
    if (hap[i] != hap[0]) n1 ++;
    else n0 ++;


  if (n1 < 2 || n0 < 2) return 1;
  return 0;

}


