#ifndef __CDataLikelihood__
#define  __CDataLikelihood__


#include <stdlib.h>
#include <string.h>


#include "COneLine.h"
#include "Const.h"
#include "CHaplotypes.h"


class CDataLikelihood
{
 private:
  char **samplenames;//name of samples
  int ns; //number of samples
  int nm; //number of markers
  int chr; //chromosomze
  int st, bl;
  int *pos; //positition of markers
  unsigned char *data;  // data [k * ns*NG + i *NG] //i: sample, k: marker
  COneLine *onelines;
  double Phred2Prob[1000];
  double Phred2LogProb[1000];

  double *bfprob;

  double * GetDataFrom(int k, double *d);

 public:
  CDataLikelihood();
  ~CDataLikelihood();
  //  void Init(char *fn, int rchr, int rst, int rbl); //Init file names from file
  void Init(char **fname, int nsample, int rchr, int rst, int rbl); //Init from list of file names
  void Display(void);


  CHaplotypes* Genotyping(void);

  int GetChr(void) {return chr;}
  int GetPos(int id) { return pos[id];}
  int GetNsite(void) { return nm;}

  char ** GetNames() { return samplenames;}
  int GetNsample() { return ns;}

  double * GetProb(int k)    { return GetDataFrom(k, Phred2Prob);}
  double * GetLogProb(int k) { return GetDataFrom(k, Phred2LogProb);}
};


#endif
