#include "CHap4ARG.h"


CHap4ARG :: CHap4ARG()
{
  nsite = 0;
  msite = 0;
  Haps = NULL;
}

CHap4ARG :: ~CHap4ARG()       
{
  for (int i = 0; i != nsite; ++i) delete Haps[i];
  if (Haps != NULL) free (Haps);
}

char **CHap4ARG::Vert2FARG(void)
{
  int ns = GetNSample();
  char ** S = (char**)calloc(2*ns, sizeof(char*)); //number of samples
  for (int i = 0; i != 2*ns; ++i)
    S[i] = (char*)calloc(nsite + 10, sizeof(char));


  for (int i = 0; i != nsite; ++i)
    {
      char *p = Haps[i]->GetHap();
      for (int j = 0; j != 2*ns; ++j)  // vert into 0, 1
	if (p[j] == p[0]) S[j][i] = '0';
	else S[j][i] = '1';
    }

  for (int i = 0; i != 2*ns; ++i) S[i][nsite] = '\0';
  return S;
}

void CHap4ARG :: Add(int chr, int pos, char *hap)        
{
  if (msite <= nsite) 
    {
      msite += 10000;
      Haps = (COneSite4ARG**)realloc(Haps, sizeof(COneSite4ARG*)*msite);
      if (Haps == NULL)
	{
	  printf("Error (re)allocating memory"); 
	  exit (1); 
	}
    }
  Haps[nsite] = new COneSite4ARG;
  Haps[nsite++]->Add(chr, pos, hap);
}





void CHap4ARG :: Display(void)
{
  for (int i = 0; i != nsite; ++i) Haps[i]->Display();
}
