#include "CHaplotypes.h"

CHaplotypes::CHaplotypes()
{
  nmarker = 0;
  nsample = 0;
  sites = NULL;

  for (int i = 'a'; i != 'z'; ++i) { Upper[i] = i - 32; lower[i] = i;}
  for (int i = 'A'; i != 'Z'; ++i) { Upper[i] = i;      lower[i] = i + 32;}
}


CHaplotypes::~CHaplotypes()
{
  if (sites != NULL) 
    {
      for (int i = 0; i != nmarker; ++i) 
	if (sites[i] != NULL) delete sites[i];
      free(sites);
    }
}


void CHaplotypes :: Init(int ns, int nm)
{
  char ** p = NULL;
  Init(ns, nm, p);
}

void CHaplotypes :: Init(int ns, int nm, char **rnames)
{
  if (sites != NULL)
    {
      for (int i =0; i != nmarker; ++i) delete sites[i];
      free(sites);
    }

  nsample = ns;
  nmarker = nm;
  names = rnames;
  sites = (COneSite**) calloc(nmarker, sizeof(COneSite*));
  for (int i = 0; i != nmarker; ++i)    sites[i] = NULL;
}

//check if H is identical with this
int CHaplotypes :: Identical(CHaplotypes* H)
{

  return 0;
  /*
  if (nsample != H->GetNsample() || nmarker != H->GetNmarker())
    {
      printf("you compare two different haplotypes\n");
      printf("%d\t%d\n", H->GetNsample(), H->GetNmarker());
      printf("%d\t%d\n", nsample, nmarker);
      return 0;
    }

  char ** hhaps = H->GetHaps();
  //  char ** hconfs = H->GetConfs();

  for (int i = 0; i != nsample; ++i)
    for (int j = 0; j != nmarker; ++j)
      if (haps[i][j] != hhaps[i][j]) return 0;
  */
  return 1;
}


void CHaplotypes :: Display(void)
{
  /*
  printf("chr = %d\n", chr);
  for (int i = 0; i != 2*nsample; ++i)
    {
      if (i %2 == 0) printf("%s\n", names[i/2]);
      haps[i][nmarker] = '\0';
      printf("%s\n", haps[i]);
      if (i %2 == 1) printf("\n");
    }
  */
  for (int k = 0; k != nmarker; ++k) sites[k]->Display(1);
}



void CHaplotypes :: Vert2MargaritaFormat(void)
{
  for (int i =0; i != nmarker; ++i) sites[i]->Vert2MargaritaFormat();
}


void CHaplotypes::SetSite(int k, COneSite *isite, int type)
{
  if (sites[k] != NULL) delete sites[k];
  if (type == 1) sites[k] = isite->Clone();
  else   sites[k] = isite;
}


CHaplotypes* CHaplotypes::Extract4ARG(void)
{
  //  printf("Extract4ARG:\n");
  printf("ok here\n");
  int* id = (int*)calloc(nmarker, sizeof(int));
  int l = 0;
  for (int k = 0; k != nmarker; ++k)
    if (sites[k]->MAF() > 1) id[l++] = k;



  CHaplotypes *H = new CHaplotypes;
  H->Init(nsample, l, names); //l = number of new marker

  for (int i = 0; i != l; ++i)
    H->SetSite(i,  sites[id[i]], 1);

  free(id);
  H->Vert2MargaritaFormat();
  //  H->Display();
  return H;
}


int* CHaplotypes :: GetPos(void)
{
  int *pos = (int*)calloc(nmarker, sizeof(int));
  for (int k = 0; k != nmarker; ++k)
    pos[k] = sites[k]->GetPos();
  return pos;
}

char ** CHaplotypes :: GetHaps(void)
{
  char ** out = Calloc(2*nsample, nmarker+1);
  for (int k = 0;  k != nmarker; ++k)
    {
      char *p = sites[k]->GetHaps();
      for (int i = 0; i != 2*nsample; ++i)  out[i][k] = p[i];
    }
  for (int i =0; i != 2*nsample; ++i) out[i][nmarker] = '\0';
  return out;
}





int CHaplotypes :: GetChr(void)
{
  if (nmarker != 0) return atol(sites[0]->GetChr());
  else return -1;
}

