#include "CNode.h"




CNode :: CNode ()
{
  s = NULL;
  active = 1;
  c1 = -1;
  c2 = -1;
  np = 0;
}

CNode :: ~CNode ()
{
  if (s != NULL) free(s);
}




void CNode :: Init(int iid, int ist,int ied, char *hap)
{
  Init(iid, ist, ied, hap,  -1, -1, -1);
}
//id, node id
//st, ed: [segment]
//hap: haplotype
//c1, c2: child id
void CNode :: Init(int iid, int ist,int ied, char *hap, int ic1, int ic2, int itype)
{
  if (s != NULL) free(s);
  s = (char*)calloc(strlen(hap) + 10, sizeof(char));
  strcpy(s, hap);

  id = iid;
  st = ist;
  ed = ied;

  c1 = ic1;
  c2 = ic2;
  type = itype;
}


//check if edge node: c2 == -1 (--> 1 child, np == 1)
int CNode :: EdgeNode(void)
{
  if (c2 == -1 && np == 1 && c1 != -1) return 1;
  return 0;
}

char *CNode :: GetHap(void) { return s;}
void CNode :: SetParent(int nparent) { np = nparent;}
int CNode:: GetST(void) { return st;}
int CNode:: GetED(void) { return ed;}

int CNode:: GetNC(void) { 
  if (c2 == -1) return 1;
  return 2;
}

int CNode:: GetNP(void) {   return np;}

void CNode::Mutation(int i)
{
  if (s[i] == '0') s[i] = '1';
  else
    if (s[i] == '1') s[i] = '0';
    else
      {
	printf("error: %s\t%d [%c]\n", s, i, s[i]);
	exit(1);
      }
}

void CNode :: Display(void)
{
  printf("%d\t%d\t%d\t%d\t%d\t%d\t", id, st, ed, c1, c2, type);

  if (active) View(s);

  /*{
    int len = strlen(s);
    for (int i = 0; i != len; ++i) 
      {
	if (s[i] == '3') printf(".");
	else printf("%c", s[i]);
	if (i  % 10 == 9) printf(" ");
      }
  }
  */

  printf("\n");
}


void CNode :: FreeHap(void)
{
  if (s != NULL) free(s);
  s = NULL;
  active = 0;
}

int CNode ::GetAl(int i)
{
  return s[i] - '0';
}


int CNode ::GetActive(void) { return active;}

int CNode :: GetChild(int i)
{
  if (i  == 1) return c1;
  else return c2;

}


int CNode ::GetType(void){  return type;}


