#ifndef __CNode__
#define __CNode__


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "Const.h"

//a node in ARG trees

class CNode
{
 private:
  int id; //node id
  int st, ed; //stard and end of this node
  int c1, c2, np; //child1, child2, num parrent
  int nc; //number of child
  int type; //type to form this node: recombination or coalescence

  char *s; //haplotypes of this node 
  int active;  //if this node in active nodes

 public:

  //Initialize, 
  //iid: node id,
  //ist, ied: [segment]
  //hap: haplotypes of this samples
  //ic1, ic2: child ids
  //itype: type to form this node: recombination or coalescence

  void  Init(int iid, int ist, int ied, char* hap, int ic1, int ic2, int itype);
  void  Init(int iid, int ist, int ied, char* hap);


  //return id of child i : i = 1, or 2
  int GetChild(int i);

  CNode();
  ~CNode();

  char *GetHap(void); //return haplotype

  int GetST(void); //return st
  int GetED(void); //return ed
  int GetActive(void); //return active (1) or not (0)


  void Mutation(int i); //mutate at site i
  void Display(void); //display


  void FreeHap(void); //free hap, deactive this node

  int GetAl(int i); //get allele at site i
  int GetType(void); //get type
  
  void SetParent(int np ); //set number of parents 1 or 2
  int GetNC(void); //get Number of childrend
  int GetNP(void); //get number of parents
  int EdgeNode(void); //check if Edge Node (*)

  void ChangeHap(int k, int v) { s[k] = (char) v;}

};


#endif


/*
*: Edge node:  node with one parent and one child.
Edge node (sl) causes by a coalescence right after a recombination


    P            /
   / \          /     
  /   \        /
x      sl    sr
        \    /
         \  /
          s(R)

sl: edge node
*/


