#include "COneLK.h"

COneLK::COneLK()
{
  name = NULL;
  chr = NULL;
  comment = NULL;
  altall = NULL;

  pos = 0;
  posend = -1;
}



COneLK::~COneLK()
{
  if (name != NULL) free(name);
  if (chr != NULL) free(chr);
  if (comment != NULL) free(comment);
  if (altall != NULL) free(altall);

}


void COneLK :: Display(void)
{
  printf("%s\t%d\t%d\t%c", chr, pos, dep, ref);
  for (int i = 0; i != NG; ++i) printf("\t%d", lk[i]);
  if (name != NULL) printf("\t%s", name);
  printf("\n");
}

/*
Input:
    <chr_s>  <pos_s> <pos_e> <alternate allele> <log likelihood of hom ref/ref>
<log likelihood of het ref/alt> <log likelihood of hom alt >  <sample
Name> [<pos_e>] %comment

*/


int COneLK :: ReadInd(FILE *f)
{
  if (f == NULL) return EOF;
  char bf[1024];

  int phred[4];
  int id[] = {0, 1, 4};

  if (name != NULL) free(name);
  if (chr != NULL) free(chr);
  if (comment != NULL) free(comment);
  if (altall != NULL) free(altall);

  name = NULL;
  chr = NULL;
  comment = NULL;
  altall = NULL;

  while (1==1)
    {
      if (feof(f)) return 0;
      strcpy(bf, "");
      fgets(bf, 1024, f);
      if (strlen(bf) < 10) continue;

      int nf;
      char **field = Split(bf, nf);
      if (nf < 8) continue;

      //      for (int i = 0; i != nf; i ++) printf("%d:[%s]\t", i, field[i]);
      //      printf("\n");

      int i = 0;
      chr = Clone(field[i++]); //chr
      pos = atoi(field[i++]);

      if (field[i][0] == '.') { posend = pos; i++;}
      else posend = atoi(field[i++]);


      if (posend < pos) 
	fprintf(stderr, "Indel: %d : %d - %d : end position > start position\n",  chr, (int) pos, (int) posend);

      altall = Clone(field[i++]);

      for (int j = 0; j != 3; ++j)
	{
	  double x = -10*atof(field[i++]); 
	  phred[j] = int(x+.5);
	}
      name = CloneScan(field[i++]);

      //      printf("%d\t%d\n", i, nf);
      if (i < nf) 
	if (field[i][0] == '%') 
	  {
	    comment  = Clone(field[i++]);
	    comment[0] = ':';
	  }

      free(field);
      ref = 'A';
      for (int i = 0;  i != NG; ++i) lk[i] = 123;

      int min = phred[0];
      for (int i = 0; i != 3; ++i)
	if (phred[i] < min) min = phred[i];

      for (int i = 0; i != 3; ++i)
	if (phred[i] - min < 123) lk [id[i]] = phred[i] - min;

      dep = 10;
      //      Display();
      return 1;
    }
  return 0;
}


int COneLK :: ReadSNP(FILE *f)
{


  if (f == NULL) return EOF; //no data
  
  char bf[1024], bf1[1024];
  char type[10];

  if (name != NULL) free(name);
  name = NULL;
  
  if (chr != NULL) free(chr);
  chr = NULL;
  int tempi;
  while (!feof(f))
    {
      if (!ReadChrPos(f, bf, pos))
	{
	  fgets(bf, 1024, f);//read the remain
	  continue;
	}

      fscanf(f, "%s", type);
      if (type[0] == '*') //indel
	{
	  fgets(bf, 1024, f);//read the remain
	  continue;
	}

      chr = (char*)calloc(strlen(bf) + 1, sizeof(char));
      strcpy(chr, bf);

      ref = type[0];

      if (ref != 'A' && ref != 'C' && ref != 'G' && ref != 'T') 	  ref = 'N';

      fscanf(f, "%d", &dep);//depth
      for (int i = 0; i != 2; ++i)        fscanf(f, "%s", bf); //read over average mapping, minquality      

      for (int i = 0; i != NG; ++i) {
	fscanf(f, "%d", &tempi);

	lk[i] = tempi;
      }
      
      fgets(bf, 1024, f);//read the remain
      if (sscanf(bf, "%s", bf1) == 1)
	{
	  name = (char*)calloc(strlen(bf1) +1, sizeof(char));
	  strcpy(name, bf1);
	}
      return 1;
    }
  return 0;
}


int COneLK :: Ident(char *s, int rpos)
{
  if (strcmp(s, chr) == 0 && pos == rpos) return 1;
  else return 0;
}



