

#include "COneLine.h"

COneLine :: COneLine()
{
  freefile = 0;
  chr = -1;
  
}

COneLine :: ~COneLine()
{
  if (freefile) free(f);
}



void COneLine :: Init(char *fn, int it)
{
  FILE *fin = fopen(fn, "r");
  Init(fin, it);
  freefile = 1;
  printf("%s\n", fn);
}



void COneLine :: Init(FILE *fin, int it)
{
  f = fin;
  filetype = it;
  Read();
}


void COneLine :: Seek(int rchr, int rpos)
{
  if (rchr == -1) return;
  if (filetype == TEXT) TextFileSeek(f, rchr, rpos);
  if (filetype == Q_BINARY) SeekBinaryFile(f, Q_BIN_BLOCKSIZE, rchr, rpos);
}



void COneLine :: Read(void)
{
  if (filetype == TEXT) ReadText();
  if (filetype == Q_BINARY) Read_Q_Binary();
  //  Display();
}


void COneLine :: Display(void)
{
  printf("%d\t%d", chr, pos);
  for (int i =0; i != NG; ++i) printf("\t%d", lk[i]);
  printf("\n");
}



void COneLine :: Read_Q_Binary(void)
{
  if (feof(f)) { chr = 100; return ;}
  
  unsigned char bf[Q_BIN_BLOCKSIZE + 10];
  fread(bf, 1, Q_BIN_BLOCKSIZE, f);
  
  chr = bf[0];
  int *p =(int*) &bf[1];

  pos = p[0];
  for (int i =0; i != NG; ++i) lk[i] = (unsigned) bf[i+5];
}



	 
void COneLine :: ReadText(void)
{
  char type[1024];
  char bf[K10];
  int tempi;

  do {
    if (fscanf(f, "%d %d %s", &chr, &pos, type) !=3 )
      {
	fgets(bf, K10, f); 
	continue;
      }

    if (type[0] == '*') { 
      fgets(bf, K10, f); 
      continue;
    }

    for (int i =0; i != 3; ++i) fscanf(f, "%d", &tempi);
    for (int i =0; i != NG; ++i) fscanf(f, "%d", &lk[i]);
  } while (1==1);
}




int COneLine :: Compare(int rchr, int rpos) 
{

  if (chr == -1) Read();
  if (chr == -1) return -1;
  //  int t =  ComparePosition(chr, pos, rchr, rpos);
  //  printf("chr = %d %d: %d %d --> %d\n", chr, pos, rchr, rpos, t);

  return ComparePosition(chr, pos, rchr, rpos);
}


void COneLine :: GetLK (unsigned char *p)
{
  for (int i =0; i != NG; ++i)   
    if (lk[i] < 255) p[i] = lk[i];
    else p[i] = 255;
}


void COneLine :: GetChrPos(int &rchr, int &rpos)
{ 
  rchr = chr; 
  rpos = pos;
}
