

#ifndef __CONESITELK__
#define __CONESITELK__

#include "COneLK.h"

/*
class to hold phred score for one site, coordinate with sample names
*/

class COneSiteLK{
 private:
  char chr[100];
  int  pos, posend;
  char  mref, ref, alt; //missing reference, ref, alt
  double conf;
  char* altall;

  char *comments;
  char *samplecomments[K1]; //maximum 1000 samples
  unsigned char  *phred; //phred[i*NG + 0,... i*NG + NG-1]
  int  *depth;

  int  ms;
  char ** samplenames;
  int nsn;//number of sample names
  int nd; //number of data
  int totaldepth;
  void Realloc(int size);


 public:
  double GetConf(void) { return conf;}
  void InitSize(int size);
  void InitSampleName(int i_nsn, char ** i_samplenames);
  void Reset(void);
  int Add(COneLK *s, int indel);

  int GetNS(void) { return nd;}

  int GetND(void) { 
    if (nsn > 0) return nsn; 
    else return nd;
  }

  int GetNsn(void) { return nsn;}
  int *GetDepth(void) { return depth;}

  char *GetChr(void) { return chr;}
  int GetChrInt(void) { return atoi(chr);}
  int GetPos(void) { return pos;}
  int GetPosEnd(void) { return posend;}


  unsigned char * GetPhred(void) { return phred;}
  unsigned char * GetLK(void) { return phred;}

  char GetRef(void) { return ref;}

  int  CheckSNPConf(void);


  int GetRefID(void);

  COneSiteLK();
  ~COneSiteLK();

  void Display(void);
  double* GetLogProb(void);

  void VCF_Write(FILE *fo) { VCF_Write(fo, NULL);}
  void VCF_Write(FILE *fo, char *comment, int indel, int *index);

  void VCF_Write(FILE *fo, char *comment)
    {
      VCF_Write(fo, comment, 0, NULL);
    }


  
  void SetConf(double i_conf) { conf = i_conf;}


  void SetAlt(char i_alt) { alt = i_alt;}
  void SetMissingRef(char m_ref) { mref = m_ref;}



  void Genotype(char *haps); //genotype p(g|d)=p(d|g) / sum_g' p(d|g')

  char *GetComment(int i) { return samplecomments[i];} 

  void SetComments(char *s);

};
#endif
