#include "CPhase.h"

CPhased::~CPhased()
{
  for (int r = 0; r != NA; ++r)
    if (ProbA[r] != NULL) free(ProbA[r]);
}


CPhased::CPhased()
{
  theta = 0.001;//human
  referror = 2*0.00001;
  log10 = log(10);

  int l = 0;


  for (int i =0; i != NA; ++i)
    for (int j = i; j != NA; ++j) {
      ID_rr[i*NA+j] = l;
      ID_rr[j*NA+i] = l;
      l++;
    }
  
  for (int r = 0; r != NA; ++r) ProbA[r] = NULL;

  exp10[0] = 1;
  log10 = log (10);
  for (int i = 1; i != 10*MAX_EXP10+10; ++i)
    {
      double x = (double) i / 10.0;
      exp10[i] = exp(-log10 * x);
      //      printf("%d\t%f\n", i, exp10[i]);
    }

  strcpy(DNA, "ACGT");
  l = 0;
  for (int a = 0; a != NA; ++a)
    for (int b = a; b != NA; ++b) 
      {
	GEN[l++] = DNA[a];
	GEN[l++] = DNA[b];
      }


  //  strcpy(GEN, "AAACAGATCCCGCTGGGTTT");

  /*
  int GID[] = {0,1,2,3,
	       1,4,5,6,
	       2,5,7,8,
	       3,6,8,9};
  */
  l = 0;
  for (int a = 0; a != NA; ++a)
    for (int b = a; b != NA; ++b) {
      GID[a*NA+b] = l;
      GID[b*NA+a] = l++;
    }
  
  //  char DNA[] = "ACGT";

}



CARG_f* CPhased :: BuildHap_Phred(CData4Phase *data,  CARG_m *arg_m, CARG_f* farg)
{
  CARG_f* larg = NULL;

  ns = data->GetNSample(); //get number of samples

  CFastARG *bfarg = new CFastARG;
  CPhased *phase = new CPhased;

  char ** sampleNames =  data->GetSampleNames();
  phase->InitSampleName(ns, sampleNames);
  //  if (arg_m == NULL && farg == NULL && larg == NULL) // no input ARGs
    {
      CHap4ARG *Gen = data->GetGen(); //get genotypes from independent samples
      larg = bfarg->Build(Gen, sampleNames);   //build ARG from GENs
      delete Gen;
    }
  //  if (larg != NULL) larg->Display();


  int nsite = data->GetNSite();
  CTree * T[K10];
  char *haps = (char*)calloc(ns * 2+10, sizeof(char));
  CHap4ARG *O_Haps = NULL;

  int nr = 0;


  while (nr ++ < 3)
    {
      CHap4ARG *Haps = new CHap4ARG;
      if (arg_m != NULL) arg_m->Reset();

      for (int i = 0; i != nsite; ++i)
	{
	  COneSiteLK *os = data->GetSite(i);

	  if (os->GetConf() < SNPCAN_TH) continue;

	  int chr = atol(os->GetChr());
	  int pos = os->GetPos();
	  int rid = os->GetRefID();

	  unsigned char *phredlk = os->GetPhred();

	  int ntree = 0;
	  //get tree from ARG_m, farg, larg
	  if (arg_m != NULL) ntree += arg_m->GetTrees(chr, pos, &T[ntree]);
	  if (farg != NULL)  ntree += farg ->GetTrees(chr, pos, &T[ntree]);
	  if (larg != NULL)  ntree += larg ->GetTrees(chr, pos, &T[ntree]);

	  //	  printf("ntree = %d\n", ntree);
	  if (ntree == 0) continue;//no tree 
	  for (int k = 0; k != ntree; ++k) T[k]->InitLK(phredlk);

	  /*
void CPhased :: Phasing(CTree ** T, int nt,
			int rid, 
			char *haps, 
			char* hapconf, 
			char* genconf)
	  */
	  //	  printf("Start phasing\n");


	  double conf = phase->ConfCal(T, ntree, rid);
	  if (conf < SNPCAN_ARG_TH) continue;
	  phase->Phasing(T, ntree, rid, 
			 haps,
			 NULL,
			 NULL);//get phasing data 

	  //	  printf("site = %d\t, %f hap = %s\n", i, conf, haps);
	  
	  if (!Singleton(haps) ) Haps->Add(atol(os->GetChr()), os->GetPos(), haps); //add chr, pos, and Haplotypes of m samples
	}
      //      Haps->Display();
      if (larg != NULL) delete larg;

      larg =  bfarg->Build(Haps, sampleNames);


      if (O_Haps != NULL)
	{
	  delete O_Haps;
	}
      O_Haps = Haps;
    }
  if (O_Haps != NULL) delete O_Haps;

  delete bfarg;
  delete phase;
  free(haps);
  return larg;
}






CHaplotypes *CPhased :: BuildHap(CDataLikelihood *d, CARG_m *arg_m, CARG_f* farg)
{
  

/*
  CHaplotypes *H = new CHaplotypes;
  H->Init(d->GetNsample(), d->GetNsite(), d->GetNames());
  CTree * T[K10];

  ns = d->GetNsample();
  priorprob = 0;
  for (int i = 1;  i != 2*ns; ++i)     priorprob += (double) 1 / (double) i;
  double t = 1 / (double) (2.0*ns);
  mu = t / (priorprob + t);
  priorprob *= theta;

  if (priorprob > 1 || priorprob < 0)
    {
      printf("priorprob = %d %f\n", ns, priorprob);
      exit(1);
    }

  for (int r = 0; r != NA; ++r)
    ProbA[r] = (double*)calloc(ns * NG, sizeof(double)); 


  for (int k = 0; k != d->GetNsite(); ++k)
    {
      double* logProb = d->GetLogProb(k);

      int chr = d->GetChr();
      int pos = d->GetPos(k);

      if (arg_m != NULL) arg_m->InitLKData(logProb); 
      if (farg  != NULL) farg ->InitLKData(logProb);
      if (larg != NULL)  larg ->InitLKData(logProb);

      
      int ntree = 0;
      //get tree from ARG_m, farg, larg
      if (arg_m != NULL) ntree += arg_m->GetTrees(chr, pos, &T[ntree]);
      if (farg != NULL)  ntree += farg ->GetTrees(chr, pos, &T[ntree]);
      if (larg != NULL)  ntree += larg ->GetTrees(chr, pos, &T[ntree]);

      if (ntree == 0) //no trees
	{
	  printf("error: no tree\n");
	  continue;
	}

      int r = ref.GetID(chr, pos);
      for (int i =0; i != NA; ++i) HomLogProb[i] = LogProb(logProb, i);

      NormFactor = HomLogProb[0];
      for (int i = 0; i != NA; ++i)
	if (NormFactor < HomLogProb[i]) NormFactor = HomLogProb[i];

      for (int i = 0; i != ntree; ++i)
	if (NormFactor < T[i]->GetMaxLogProb()) NormFactor =  T[i]->GetMaxLogProb();

      //      printf("normfactor = %f\n", NormFactor);

      COneSite *s = new COneSite;
      s->SetConf(ConfidenceCalculation (logProb, T, ntree, r) );
      s->SetChrPos(chr, pos);
      //      s->Display();
      if (s->GetConf() > .01)      {
	Phasing(logProb, T, ntree, r,  s);
	Genotyping(logProb, T, ntree, r, s);
      }
      H->SetSite(k, s, 0);
    }
  for (int r = 0; r != NA; ++r) free(ProbA[r]);
  for (int r = 0; r != NA; ++r) ProbA[r] = NULL;
  return H;
*/
  return NULL;
}  


/*

void CPhased :: Genotyping(CTree **T, int nt, 
			   int rid, 
			   COneSite *s)
{
  char ** CharArr = s->GetCharArr();
  Genotyping(logProb, T, nt, rid, CharArr[2], CharArr[3]);
}




void CPhased :: Genotyping(double *logProb, CTree **T, int nt, int rid, char* gens, char* genconf)
{

  for (int r = 0; r != NA; ++r)
    for (int i = 0; i != ns * NG; ++i) ProbA[r][i] = 0; //probgens[i][j] = 0;
  
  //  int *index = T[0]->GetIndex();

  double priorprobtree = 1 / (double) nt;
  
  for (int k = 0; k != nt; ++k)
    {
      CTree *t = T[k];  //take k^th tree 
      int nfig = t->GetNumFigs(); 
      double ** logProbFig = t->GetLogProbFig();
      double *  priorprobfig = t->GetPP();
      char   ** figs       = t->GetFig();

      for (int i = 0; i != nfig; ++i)
	for (int a = 0; a != NA; ++a)
	  for (int b = 0;  b != NA; ++b)
	    if (a != b)
	      {
		if (logProbFig[i][a*NA+b] - NormFactor > MIN_THRESHOLD)
		  {

		    double prob = exp(logProbFig[i][a*NA+b] - NormFactor);
		    prob *= priorprobfig[i]; 
		    prob *= (1-mu);
		    prob *= priorprobtree;
		    prob *= pab;

		    char *fig = figs[i];
		    int id_aa =  ID_rr[a*NA + a];
		    int id_ab =  ID_rr[a*NA + b];
		    int id_bb =  ID_rr[b*NA + b];
		    int id;

		    for (int l = 0; l != ns; ++l)
		      {
			int j = index[l];
			if (j == -1) continue;

			if (fig[l*2] != fig[l*2+1]) id = id_ab;
			else
			  if (fig[l*2] == '0' || fig[l*2] == 0) id = id_aa;
			  else id = id_bb;

			ProbA[a][j*NG + id] += prob; //r = a
			ProbA[b][j*NG + id] += prob; //r = b
		      }
		  }
	      }
    }


  //  double quarter = 1.0 / 4.0;
  for (int a = 0; a != NA; ++a)
    {
      double prob = exp(HomLogProb[a] - NormFactor);
      prob *= mu;

      int id_aa =  ID_rr[a*NA + a];    

      for (int r = 0; r != NA; ++r)
	if (r != a)
	  for (int j = 0; j != ns; ++j)
	    ProbA[r][j * NG + id_aa] += prob;

    }

  for (int r = 0; r != 4; ++r)
    for (int j = 0; j != ns; ++j) Norm(&ProbA[r][j*NG]);
    
  double priorprobref[NA];
  for (int r = 0; r != NA; ++r) priorprobref[r] = PriorRefError(r, rid);

  double PostProb[NG];
  
  for (int j = 0; j != ns; ++j)
    {
      for (int i = 0; i != NG; ++i) PostProb[i] = 0;

      for (int i = 0; i != NG; ++i)
	for (int r = 0; r != NA; ++r) PostProb[i] += ProbA[r][j*NG + i] * priorprobref[r];
	
      Norm(PostProb);
    }

}
*/




void CPhased :: InitSampleName(int nsample, char** samples) 
{
  ns = nsample;
  samplenames = samples;

  for (int r = 0; r != NA; ++r)
    if (ProbA[r] == NULL)
      ProbA[r] = (double*) calloc(ns * NG, sizeof(double));
}





void CPhased :: Phasing(CTree ** T, int nt, 
			int rid, 
			COneSite *s)
{
  char ** charArr = s->GetCharArr();
  Phasing(T, nt, 
	  rid, 
	  charArr[0], 
	  charArr[1], 
	  charArr[4]);
}




void CPhased :: Genotyping(CTree ** T, int nt, 
			   int rid, 
			   COneSite *s)
{
  char ** charArr = s->GetCharArr();
  Genotyping(T, nt, 
	     rid, 
	     charArr[2], 
	     charArr[3]);
}



void CPhased :: Genotyping(CTree ** T, int nt, 
			   int rid,
			   char* gens,
			   char* genconf)
{
  Initial(T, nt, rid);

  //  printf("norm factor = %d\n", NormFactor);
  for (int r = 0; r != NA; ++r)
    for (int i = 0; i != ns*NG; ++i) ProbA[r][i] = 0;

  for (int k = 0; k != nt; ++k)
    {
      CTree *t = T[k];  //take k^th tree 
      int nfig = t->GetNumFigs(); 
      int * PhredConf = t->GetPhredConf();
      double *  priorprobfig = t->GetPP();
      char   ** figs       = t->GetFig();

      for (int i = 0; i != nfig; ++i)
	for (int a = 0; a != NA; ++a)
	  for (int b = 0;  b != NA; ++b)
	    if (a != b) // a [0] -> b[1]
	      {
		int id = i*NA2+a*NA+b; //the location of figure i, al1 =a, al2 = b
		if (PhredConf[id] - NormFactor >= 10*MAX_EXP10) continue;//ignore cases with too small values

		double prob = 0;
		if (PhredConf[id] - NormFactor < 10*MAX_EXP10)  prob += exp10[PhredConf[id] - NormFactor];

		prob *= priorprobfig[i]; 
		prob *= priorprobtree;
		prob *= pab;
		double prob1 = prob * (1-mu);
		char *fig = figs[i];


		//printf("%s\t%d\t%d\t%d\n", fig, a, b, PhredConf[id] - NormFactor);
		for (int l = 0; l != ns; ++l)
		  {
		    if (fig[l*2] != fig[l*2+1]) //het, ab
		      {
			ProbA[a] [l*NG + GID[a*NA+b]] += prob/2; //r = a
			ProbA[b] [l*NG + GID[a*NA+b]] += prob/2; //r = b
			continue;
		      }

		    if (fig[l*2] == '0' || fig[l*2] == 0) //hom: aa 
		      {
			ProbA[a][l*NG + GID[a*NA+a]] += prob;
			ProbA[b][l*NG + GID[a*NA+a]] += prob1; //r = b, r != a
		      }
		    else //hom bb
		      {
			ProbA[b][l*NG + GID[b*NA+b]] += prob;
			ProbA[a][l*NG + GID[b*NA+b]] += prob1; //r = b, r != a
		      }
		  }
	      }

    }

  for (int a = 0; a != NA; ++a)
    {
      if (HomPhred[a] - NormFactor >= 10*MAX_EXP10) continue;

      double prob = 0;
      if (HomPhred[a] - NormFactor < 10*MAX_EXP10) prob += exp10[HomPhred[a] - NormFactor];

      prob *= mu;
      prob *= pab;


      for (int r = 0; r != NA; ++r)
	if (r != a) 
	  for (int j = 0; j != ns; ++j) ProbA[r][j*NG +  GID[a*NA+a]] += prob;
    }

  for (int i = 0; i != ns; ++i)//sample i
    for (int r = 0; r != NA; ++r) Norm(&ProbA[r][i*NG], NG);


  double *PostProb = (double*)calloc(ns*NG, sizeof(double));

  for (int i = 0; i != ns; ++i)//sample i
    {
      double *p = &PostProb[i*NG];
      for (int id = 0; id != NG; ++id) p[id] = 0;

      for (int id = 0; id != NG; ++id)
	for (int r = 0; r != NA; ++r)
	  p[id] += priorprobref[r] * ProbA[r][i*NG + id];
      Norm(p, NG);
    }


  for (int i = 0; i != ns; ++i)
    {
      double *p = &PostProb[i*NG];
      int mid = 0;
      for (int id = 0; id != NG; ++id)
	if (p[mid] < p[id]) mid = id;

      for (int l = 0; l != 2; ++l) gens[2*i+l] = GEN[mid*2+l];
      genconf[i] = 33 + Prob2Phred(1 - p[mid]);
    }

  gens[2*ns] = '\0';
  genconf[ns] = '\0';
  free(PostProb);
}




void CPhased :: Phasing(CTree ** T, int nt,
			int rid, 
			char *haps, 
			char* hapconf, 
			char* genconf)
{
  
  //  printf("coming here: Phasing\n");

  double priorprobtree = 1.0 / (double) nt;

  for (int r = 0; r != NA; ++r)
    for (int i = 0; i != ns*2*NA; ++i) ProbA[r][i] = 0;

  Initial(T, nt, rid);



  if (DISPLAY) printf("NormFactor = %d\n", NormFactor);

  double pab = 1.0 / 3.0;

  for (int k = 0; k != nt; ++k)
    {
      CTree *t = T[k];  //take k^th tree 
      int nfig = t->GetNumFigs(); 
      int * PhredConf = t->GetPhredConf();
      double *  priorprobfig = t->GetPP();
      char   ** figs       = t->GetFig();

      for (int i = 0; i != nfig; ++i)
	for (int a = 0; a != NA; ++a)
	  for (int b = 0;  b != NA; ++b)
	    if (a != b) //recode from here
	      {
		int id = i*NA2+a*NA+b; //the location of figure i, al1 =a, al2 = b
		if (PhredConf[id] - NormFactor >= 10*MAX_EXP10) continue;//fig with Prob > exp(MIN_THRESHOLD)

		double prob = 0;

		if (PhredConf[id] - NormFactor < 10*MAX_EXP10)  prob += exp10[PhredConf[id] - NormFactor]; //exp(logProbFig[i][a*NA+b] - NormFactor);

		prob *= priorprobfig[i]; 
		prob *= priorprobtree;
		prob *= pab;
		double prob1 = prob * (1-mu);

		if (DISPLAY && PhredConf[id] == NormFactor) {
		  printf("%d\t%d : %s: %d %d: %d : %e %e [%d]\n", k, i,figs[i], a, b, PhredConf[id] - NormFactor, prob, prob1, NormFactor);

		  //		  for (int k = 0; k != strlen(figs[i]);  ++k)
		  //		    if (figs[i][k] == '1')  printf("sample\t%d\n", k/2);
		  //		  printf("\n");

		  for (int k = 0; k < (int) strlen(figs[i]);  k += 2)
		    printf("sample: %d\t%c\t%c\n", k/2, figs[i][k], figs[i][k + 1]);


		  int idd = 9;
		  printf("id = %d, %c\t%c\n", idd,  figs[i][idd*2], figs[i][idd*2+1]);
		}


		char *fig = figs[i];
		for (int l = 0; l != ns; ++l)
		  for (int ll = 0; ll != 2; ++ll)
		    {
		      int j = l*2 + ll; //haplotype of sample l, genotype ll

		      if (fig[j] == '0' || fig[j] == 0)  // fig[j] = a
			{
			  ProbA[a][j*NA+a] += prob;   //r = a 
			  ProbA[b][j*NA+a] += prob1;  //r = b, r!=a
			}
		      else
			{
			  ProbA[a][j*NA+b] += prob1;  //r = a, r !=b
			  ProbA[b][j*NA+b] += prob;   //r = b 
			}
		    }
	      }
    }
  //mu * p(D|h = a)
  //  double quarter = 1.0 / 4.0;


  for (int a = 0; a != NA; ++a)
    {
      if (HomPhred[a] - NormFactor >= 10*MAX_EXP10) continue;


      double prob = 0;
      if (HomPhred[a] - NormFactor <  10*MAX_EXP10) prob += exp10[HomPhred[a] - NormFactor];

      prob *= mu;
      prob *= pab;
      //      printf("prob = %e\n", prob);

      for (int r = 0; r != NA; ++r)
	if (r != a)
	  for (int j = 0; j != 2*ns; ++j)  ProbA[r][j*NA + a] += prob;
    }

  //normalize to get p(h_a | D, T, r) = p(D, h_i= |T, r) / normalize

  for (int i = 0; i != 2*ns; ++i)
    for (int r = 0; r != NA; ++r) Norm(&ProbA[r][i*NA], NA);

  //  double PostProb[NA];
  //for each sample i, PostProb[a] = sum_r prior[r] * prob(h_i=a|D, T, r)
  //where prob(h_i=a |D, T, r) = probA[r][i*NA + a]

  double *PostProb = (double*)calloc(ns*2*NA, sizeof(double));
  //  double priorprobref[NA];    
  //  for (int r = 0; r != NA; ++r) priorprobref[r] = PriorRefError(r, rid);

  for (int i = 0; i != ns*2; ++i)
    {
      double *p = &PostProb[i*NA];
      for (int a = 0; a != NA; ++a) p[a] = 0;

      for (int a = 0; a != NA; ++a)
	for (int r = 0; r != NA; ++r) 
	  p[a] += priorprobref[r] * ProbA[r][i*NA + a];
      Norm(p, NA);
    }

  //  if (hapconf != NULL) 
  for (int i = 0;  i != ns*2; ++i)
    {
      double *p = &PostProb[i*NA];
      int ma = 0;
      for (int a = 0; a != NA; ++a)
	if (p[a] > p[ma]) ma = a;
      
      haps[i] = DNA[ma];
      if (hapconf != NULL) hapconf[i] = 33 + Prob2Phred(1 - p[ma]);
    }

  if (genconf != NULL)
    {
      for (int i = 0;  i != ns; ++i)
	{
	  double *p1 = &PostProb[2*i*NA];
	  double *p2 = &PostProb[(2*i+1)*NA];
	  int a = MaxProb(p1, NA);
	  int b = MaxProb(p2, NA);

	  if (a == b) genconf[i] = Prob2Phred(1 - p1[a] * p2[b]) + 33;
	  else genconf[i] = Prob2Phred(1 - (p1[a] * p2[b] + p1[b] * p2[a]) ) + 33;

	}
      genconf[ns] = '\0';
    }
}



double CPhased :: PriorRefError(int r, int rid)
{
  double prior = 1.0/4.0;      
  if (rid != -1)      
    if (r != rid) prior = referror/3;     
    else prior = 1 - referror;     
  return prior;
}

/*
double CPhased :: ConfidenceCalculation(double *logProb, CTree** T, int nt, int rid)
{
  //calculate the posterior probability of logProb | T, nt. rid: reference id
  //p0 = sum_r p(r|rid) p(logProb|rr) //no mutation

  //  printf("Calculating posterior probability\n");

  double p1 = 0, p0 = 0;
  for (int r = 0; r != 4; ++r)
    {
      double prior = PriorRefError(r, rid);
      double sumprob = 0;
      for (int i = 0; i != nt; ++i)
	sumprob += LogProb(logProb, T[i], r);

      p1 += prior * sumprob;
      p0 += prior * EXP(HomPhred[r] - NormFactor);
    }

  //  printf("p0 = %f\n", p0);

  p1 /= (double) nt;//because we have nt trees
  //  printf("%f\t%f\n", p0, p1);
  if (p1 < 0 || p0 < 0 || priorprob < 0 || priorprob > 1) {
    printf("we have problem here: %f %f %f \n", p1, p0, priorprob);
    for (int i = 0;  i != nt; ++i) T[i]->Display();
    exit(1);
  }

  double conf = p1 * priorprob / ( p1 * priorprob + p0 * (1-priorprob) );
  return conf;
}
*/

/*
double CPhased :: LogProb(double *logProb, int r)
{
  int id = ID_rr[r*NA+r];
  double out = 0;
  for (int i = 0; i != ns; ++i) out += logProb[i*NG + id];
  return out;
}
*/

/*
double CPhased :: LogProb(double *logProb, CTree *t, int r)


  double out = 0, tempd = 0;
  for (int a = 0; a != NA; ++a)
    if (a != r) tempd += EXP(HomLogProb[a] -NormFactor);
  out += mu * tempd;

  tempd = 0;
  int nfig = t->GetNumFigs();
  double *priorprobfig = t->GetPP();
  double ** logprob = t->GetLogProbFig();


  //  DisplayVectDouble(priorprobfig, nfig);
  
  for (int i = 0; i != nfig; ++i)
    {
      double pp = priorprobfig[i];
      //      printf("%d\t%f\n", i, pp);

      double *p = logprob[i];

      for (int a = 0; a != NA; ++a)
	if (a != r)
	  tempd +=  EXP(p[ ID_rr[r *NA + a]]-NormFactor) * pp  
	          + EXP(p[ ID_rr[a*NA + r] ]-NormFactor) * pp;
      tempd /= 3.0; //we have three possible a, a != r
    }
  out += (1-mu) * (tempd/2);
  return out;

  return 0;
}
*/



int CPhased :: Prob2Phred(double x)
{
  if (x == 0) return 90; 
  double t = -10 * log (x) / log10;
  if (t > 90) return 90;
  return lround (t);
}


void CPhased :: Initial(CTree**T, int nt, int rid)
{
  //  printf("coming to Initial: ns = %d\n\n", ns);
  for (int r = 0; r != NA; ++r) priorprobref[r] = PriorRefError(r, rid);  
  int * PhredConf = T[0]->GetPhredConf(); 
  for (int a = 0; a != NA; ++a) HomPhred[a] = PhredConf[0 + a*NA +a]; 

  //  printf("step 0\n");
  NormFactor = T[0]->GetMinValue();
  for (int i = 0; i != nt; ++i)
    if (NormFactor > T[i]-> GetMinValue()) NormFactor =  T[i]-> GetMinValue();

  //  printf("step 1\n");
  pab = 1.0 / 3.0;
  priorprobtree = 1.0 / (double) nt;
  double priorprob = 0;
  for (int i = 1;  i != 2*ns; ++i)     priorprob += (double) 1 / (double) i;
  double t = 1 / (double) (2.0*ns);
  mu = t / (priorprob + t);

  //  printf("step 2\n");
}



double CPhased::ConfCal(CTree**T, int nt, int rid)
{
  Initial(T, nt, rid);



  double phom = 0;
  for (int r = 0; r != NA; ++r)
    if (HomPhred[r] - NormFactor  < 10*MAX_EXP10 ) phom +=   exp10[HomPhred[r] - NormFactor] * priorprobref[r]; 

  /*
  printf("rid = %d, %e\n", rid, phom);

  for (int i =0; i != NA; ++i) printf("%d\t", HomPhred[i]);
  printf(":%d\n", NormFactor);
  */

  double total_phet = 0;
  for (int r = 0;  r != NA; ++r)
    {
      double het = 0;
      for (int a = 0; a != NA; ++a)

	if (a != r) 
	  if (HomPhred[r] - NormFactor < 10*MAX_EXP10) het += mu * pab *  exp10[HomPhred[r] - NormFactor];    
      
      for (int k = 0; k != nt; ++k)
	{
	  CTree *t = T[k];  //take k^th tree 
	  int nfig = t->GetNumFigs(); 
	  int * PhredConf = t->GetPhredConf();
	  double *  priorprobfig = t->GetPP();

	  for (int i = 0; i != nfig; ++i)
	    for (int a = 0; a != NA; ++a)
	      if (a != r) 
		{
		  int id  = i*NA2+a*NA+r;
		  int id1 = i*NA2+r*NA+a;


		  if (PhredConf[id] - NormFactor  >= 10*MAX_EXP10 && PhredConf[id1] - NormFactor  >= 10*MAX_EXP10) continue;
		  
		  double prob = 0;

		  if (PhredConf[id] - NormFactor < 10*MAX_EXP10) prob += exp10[PhredConf[id] - NormFactor];
		  if (PhredConf[id1] - NormFactor <  10*MAX_EXP10) prob += exp10[PhredConf[id1] - NormFactor];



		  prob *= priorprobfig[i];    
		  prob *= priorprobtree;    
		  prob *= pab;     		  
		  prob *= (1-mu);  
		  prob /= 2.0;
		  het += prob;
		}
	}
      total_phet += het;
    }

  double pdt = 0;
  for (int i = 1; i != 2*ns; ++i) pdt += 1.0 / (double) i;
  pdt *= theta;

  double x = 0;
  if (total_phet * pdt + phom * (1-pdt) > 0)
    x = total_phet * pdt / (total_phet * pdt + phom * (1-pdt));

  return x;
}






int CPhased :: Singleton(char *hap)
{
  int len = strlen(hap);
  //  for (int i =0; i < len; i += 2)
  //    if (hap[i] != hap[i+1]) np ++;
  int n0 = 0, n1 = 0;
  for (int i = 0;  i != len; ++i)
    if (hap[i] != hap[0]) n1 ++;
    else n0 ++;

  if (n1 < 2 || n0 < 2) return 1;
  return 0;
}
