#ifndef __PHASE__
#define __PHASE__



#include "CARG_m.h"
#include "CARG_f.h"
#include "CHaplotypes.h"
#include "CDataLikelihood.h"
#include "CTree_SamtoolLK.h"
#include "CReadFA.h"
#include "COneSite.h"

#include "CData4Phase.h"
#include "CFastARG.h"
#include "CHap4ARG.h"



class CPhased 
{
 private:
  CReadFA ref;

  char DNA[NA+1];
  char GEN[NG*2+10];
  int  GID[NA2];

  double *ProbA[NA]; //probgens[r][i*NG   +j]  = probablity of sasmple i, given genotype j, reference r
                     //probhaps[r][i*2*NA + j] = probability of haplotype 2*i, given allel j, reference r

  double exp10[MAX_EXP10*10 + 10];
  double prioprob;
  double theta;
  double referror;

  int ID_rr[16];

  double mu;

  //  double LogProb(double *logProb, CTree *t, int r);
  //  double LogProb(double *logProb, int r);

  int ns;
  char **samplenames;


  double PriorRefError(int r, int rid);


  //  CARG_f* BuildHap_Phred(CData4Phase *data,  
  //			 CARG_m *arg_m, 
  //			 CARG_f* farg);
			 //			 CARG_f* larg);

  void Phasing(CTree ** T, int nt, 
	       int rid, 
	       char *haps, 
	       char* hapconf, 
	       char* genconf);

  
  void Genotyping(CTree** T, int nt, 
		  int rid,
		  char* gens,
		  char* genconf);



  double log10;
  int Prob2Phred(double x);
  double priorprobref[NA];    
  int HomPhred[NA];
  int NormFactor; 
  double pab;
  double priorprobtree;



  void Initial(CTree**T, int nt, int rid);



 public:
  CPhased();
  ~CPhased();


  void Phasing(CTree ** T, int nt, 
	       int rid, 
	       COneSite* s);



  void Genotyping(CTree**T, int nt, 
		  int rid, 
		  COneSite *s);





  CHaplotypes *BuildHap(CDataLikelihood *d, 
			CARG_m *arg_m, 
			CARG_f* iarg);

  void InitSampleName(int nsample, char** samples);// { ns = nsample; samplenames = samples;}
  double ConfCal(CTree** T, int nt, int rid);

  CARG_f* BuildHap_Phred(CData4Phase *data,  CARG_m *arg_m, CARG_f* farg);

  int Singleton(char *s);
};




#endif


