#include "CReadData.h"

CReadData::CReadData()
{
  samplenames = (char**)calloc(K10, sizeof(char*));
  nsn = 0;

  s = NULL;
  os = NULL;
  indel = 0;//SNP

  fchr = -1;
  fpos = -1;
  ff = NULL;
}



CReadData::~CReadData()
{
  for (int i =0; i != nsn; ++i) free(samplenames[i]);
  free(samplenames);
  if (s != NULL) delete s;
  if (os != NULL) free(os);
  if (ff != NULL) fclose(ff);
}

void CReadData :: SetSampleNames(char *fn)
{
  FILE *f = fopen(fn, "r");
  if (f == NULL) 
    {
      printf("error open files of samples: %s\n", fn);
      exit(1);
    }
  nsn = 0;
  char tempc[1024];
  while (!feof(f))
    {
      if (fscanf(f, "%s", tempc) != 1) continue;
      samplenames[nsn] = (char*)calloc(strlen(tempc) + 1, sizeof(char));
      strcpy(samplenames[nsn++], tempc);
    }
  fclose(f);

  if (os != NULL) free(os);
  os = new COneSiteLK;
  os->InitSampleName(nsn, samplenames);
}


COneSiteLK* CReadData :: Read(void)
{
  if (os == NULL) NewOS();
  else os->Reset();

  if (s == NULL) { 
    s = new COneLK;         
    if (!s->Read(fin, indel)) return NULL;
  }
  //  s->Display();

  while (1==1)
    {
      int add = 1;
      if (ff != NULL)
	if (!Exist(s->GetChrInt(), s->GetPos())) add = 0;

      if (add) 
	if (os->Add(s, indel) == NEWSITE) break; //find new site

      if (!s->Read(fin, indel)) { delete s;  s = NULL; break;} //end of file
    }
  return os;
}

void CReadData :: NewOS(void)
{
  os = new COneSiteLK;
  if (nsn > 0)
    os->InitSampleName(nsn, samplenames);
}



void CReadData :: SetFilter(char *fn)
{
  if (ff != NULL) fclose(ff);
  ff = fopen(fn, "r");
  if (ff == NULL) {
    printf("error in opening filter file: %s\n", fn);
    exit(1);
  }
}


int CReadData :: Exist(int chr, int pos)
{
  printf("%d\t%d: \t%d\t%d\n", chr, pos, fchr, fpos);

  if (chr == fchr && pos == fpos) return 1;
  if (feof(ff)) return 0;

  if (chr != fchr || pos < fpos || pos - fpos > M1) TextFileSeek(ff, chr, pos); //seek to chr, pos
  printf("seek file ok\n");
  
  int ok = GetChrPos(ff, fchr, fpos);



  while (ok && !feof(ff))
    {
      //      printf("%d\t%d\n", fchr, fpos);
      if (fchr < chr || (fchr == chr &&  fpos < pos)) 	ok  =  GetChrPos(ff, fchr, fpos);                
      else break;
    }
  
  if (fchr == chr && fpos == pos) return 1;
  return 0;
}
