#ifndef __CReadDataOneLK__
#define __CReadDataOneLK__
#include "COneLK.h"
#include "CVCF.h"
#include "SNPCandidate.h"
#include "SNPCanList.h"
#include <iostream>
#include <ctime>
#include "Const.h"

struct OneSite{
  COneLK** data;
  int ndata;
};

class CReadDataOneLK
{
 private:
  COneLK** lkdata;
  int nlk;//number of likelihood like

  //  OneSite * site; //number of sites
  //  int ns; //number of sites

  int mlk; //maximum number of record
  int cid; //current id
  FILE *f;
  double Phred2LK[K1];


  //  CVCF *vcf;
  //  CSNP * snpdec;
  
  //  SNPCanList *snpcan;
  //  char fnoutcan[1024];
  //  FILE *fco;


  //  int freefin;
  //  int OrderDNA[1000];
  //  char DNA[10];


  int tempfile;
  char ** samplenames;
  int nsn; 

  int keepdata;

  int order[NA][NA];

  double* GetLK(OneSite *s);
  void GetLK(COneLK *data, double *out);


  double pphet, pphom;

 public:
  CReadDataOneLK();
  ~CReadDataOneLK();

  void Read(int nr);
  void Read(void) { Read(-1);}

  void Display(void);
  void Init(FILE *fin) { f = fin;}
  void Init(char *fn);

  void Free(void);

  COneLK** GetSite(int &n);
  void Test(void);
  
  int SNPCanFilter(OneSite *s);//filter 

  int TotalDepth(OneSite *s);
  void InitSNPDec(CSNP *ssnpdec) { snpdec = ssnpdec;}
  void SetSNPCanOut(char *fn);// {  fco = fopen(fn, "w"); }
  void SetVCF(char *fn);
  void PushNames(char *s);
  void VCF_Write_SNPCan(void);

  void VCF_Write_Header(FILE *fco, int phased);
  void VCF_Write_OneSite(FILE *fco, VCFSNPCAN *site, OneSite *s);
  void PushOneSite( COneLK *p );


  void FixedVCFFile(void);


  void Display(OneSite *s); 
  void SetSampleNames(char *fn);

  void SetPPHet(double pphet);

};
#endif



