#include "CReadStream.h"
#include "Const.h"

CReadStream::CReadStream(){
  ln10 = log(10);
  f = NULL;
  
  chr = -1;
  char DNA[] = "ACGT";

  for (int i =0; i != 4; ++i) CodeDNA[ (int)DNA[i]]  = i;
  for (int i =0; i != 4; ++i) CodeDNA[ (int) DNA[i] + 32]  = i;
  //  Read();
}

void CReadStream::Init(char* fn)
{
  FILE *fin = fopen(fn, "r");
  if (fin == NULL) {
    printf("Error: %s\n", fn);
    exit(1);
  }
  Init(fin);
}


void CReadStream::Init(FILE *fin)
{
  f = fin;
  Read();
}



void CReadStream::Read(void)
{

  char type[10];
  chr = -1;
  int tempi;

  char schr[1024];

  while (!feof(f))
    {
      if (fscanf(f, "%s %d %s", schr, &pos, type) != 3) { fgets(bf, 1000, f); continue;};

      if (type[0] == '*') //indel
	{
	  fgets(bf, 1000, f);
	  continue;
	}

      chr = CHR(schr);
      rid = CodeDNA[ (int) type[0] ];

      for (int i = 0; i != 3; ++i) fscanf(f, "%d", &tempi);
      for (int i = 0; i != NG; ++i) fscanf(f, "%d", &lk[i]);
      break;
    }
}



int CReadStream :: GetData(int &rchr, int &rpos, int &rrid, double *prob)
{
  int ns = 0;
  rchr  = chr;
  rpos  = pos;
  rrid = rid;

  if (chr == -1) return 0;

  while (rchr == chr && rpos == pos)
    {
      for (int i = 0; i != NG; ++i)
	prob[ns * NG + i] = Phred(lk[i]);
      ns++;
      Read();
      //      printf("%d\t%d\n", chr, pos);

    }
  return ns;
}


void CReadStream :: Display(int ns, int chr, int pos, int rid,  double *prob)
{
  printf("%d\t%d\t: %d, %d\n", chr, pos, ns, rid);
  for (int i =0; i != ns; ++i) 
    {
      for (int j = 0; j != NG; ++j)
	printf("%.2f\t", prob[i * NG + j]);
      printf("\n");
    }
}


double CReadStream :: Phred(int x)
{
  double t = -x;
  double p = exp(t/10 * ln10);
  return p;
}



