#include "CSNPDetection.h"
#include "CReadStream.h"
#include "SNPCandidate.h"


SNPs* SNPDetection :: SNPDetectionFromStream(FILE *f, 
					     int rchr, int rst, int red, 
					     double threshold, 
					     int maxN,
					     int &no  ) //number of output
{
  CReadStream cdata;               
  cdata.Init(f);    

  CSNP snpcan;
  snpcan.Init(maxN);

  int maxcan = 100000;
  SNPs* out = (SNPs*)malloc(maxcan *  sizeof(SNPs));
  
  double *p = (double*)calloc(10000, sizeof(double));
  int ns, chr, pos, rid;
  int nr = 0;

  do{
    ns = cdata.GetData(chr, pos, rid, p);

    if (rchr != -1)
      {
	if (chr > rchr || (chr == rchr && pos > red)) break;
	if (chr < rchr || (chr == rchr && pos < rst)) continue;
      }

    double t = snpcan.SNPConfidence(p, ns, rid);

    if (t > threshold) 	
      {
	out[no].chr = chr;
	out[no].pos = pos;
	out[no].rid = rid;
	out[no].conf = t;
	no ++;

	if (no + 10 >= maxcan) 
	  {
	    maxcan += 100000;
	    out = (SNPs*)realloc(out, maxcan * sizeof(SNPs));
	  }
      }

    if (nr++ % 1000 == 0) printf("number of SNP can: %d/%d\n", no, nr);

  }while (ns != 0);

  free(p);

  return out;
};
