#include "CTree_SamtoolLK.h"


CTree :: CTree()
{
  PhredConf = NULL;
}


CTree :: ~CTree()
{
  if (PhredConf != NULL)    free(PhredConf);
}

void CTree :: InitLK(unsigned char* i_PhredLK)
{

  phredLK = i_PhredLK;

  //NA2 = NA*NA
  int numfigs = GetNumFigs();

  //  if (PhredConf == NULL) exit(1);
  if (PhredConf != NULL)    free(PhredConf);

  //  printf("coming here: L23\n");

  PhredConf = (int*)calloc(numfigs*NA2, sizeof(int));


  int hom[4];
  char **figs = GetFig();
  for (int a = 0;  a != NA; ++a) hom[a] = exp10(figs[0], a, a);

  for (int i = 0; i != numfigs; ++i)
    for (int a = 0; a != NA; ++a)
      for (int b = 0; b != NA; ++b)
	if (a != b) PhredConf[i*NA2 + a*NA + b ] = exp10(figs[i], a, b);
	else PhredConf[i*NA2+a*NA + b] = hom[a];


  minvalue = PhredConf[0];
  for (int i = 0; i != numfigs * NA2; ++i)
    if (minvalue > PhredConf[i]) minvalue = PhredConf[i];
}


int CTree :: exp10(char *fig, int a, int b)
{

  int order[] = {0,1,2,3,
		 1,4,5,6,
		 2,5,7,8,
		 3,6,8,9};
  
  int id_aa = order[a*NA+a];
  int id_ab = order[a*NA+b];
  int id_bb = order[b*NA+b];


  int sumphredLK  = 0;

  int nsp = GetSNP();
  for (int i = 0; i != nsp; ++i)
    {
      unsigned char *p = &phredLK[i*NG]; // phred score of sample i
      if (fig[2*i] != fig[2*i+1])  sumphredLK += p[id_ab];
      else
	if (fig[2*i]  == 0 || fig[2*i] == '0') sumphredLK += p[id_aa];
	else sumphredLK += p[id_bb];
    }
  return sumphredLK;
}




