#include "CVCF.h"


CVCF::CVCF()
{
  ns = 0;
  f = NULL;
  closefile = 0;
  chr = 0;
  pos = 0;
  strcpy(schr, "00");
}


CVCF::~CVCF()
{
  ns = 0;
  for (int i =0; i != ns; ++i) free(samples[i]);
  if (closefile) fclose(f);
  
}


void CVCF :: Init(char* fn)
{
  FILE *fin = fopen(fn, "r");
  closefile = 1;
  Init(fin);
}



void CVCF :: ReadFirstData(void)
{
  if (f == NULL) return;

  while (!feof(f))
    {
      fgets(bf, MAXLEN, f);
      if (strstr(bf, "#CHROM") == bf) break;
    }

  Split(bf);
  ns = 0;
  for (int i = 9; i  != n; ++i)
    {
      samples[ns] = (char*)calloc(strlen(data[i])+1, sizeof(char));
      strcpy(samples[ns++], data[i]);
    }
}

void CVCF :: Display(void)
{
  for (int i = 0; i != n; ++i)
    printf("%s\t", data[i]);
  printf("\n");

}


int  CVCF::Split(char *bf)
{
  n = 0;
  data[n++] = bf;

  int len = strlen(bf);
  while (len >= 0 && bf[len] < 33) len --;
  bf[len+1] = '\0';

  for (int i = 0; i != len; ++i)
    if (bf[i] == '\t') {
      data[n++] = &bf[i+1];
      bf[i] = '\0';
    }

  //  for (int i = 0; i != n; ++i) printf("%s\n", data[i]);

  return n;
}


void CVCF :: SetIndex(char ** names, int rns1)
{
  rns = rns1;
  for (int i =0; i != rns; ++i)    index[i] = -1;

  for (int i = 0; i != rns; ++i)
    for (int j = 0; j != ns; ++j)
      if (strcmp(names[i], samples[j]) == 0) index[i] = j;

  //  for (int i =0; i !=rns; ++i) printf("%s\t%d\n", names[i], index[i]);
}


int CVCF :: ReadData(void)
{
  while (f != NULL && !feof(f))
    {
      strcpy(bf, "");
      fgets(bf, MAXLEN, f);
      if (strlen(bf) == 0) continue;
      Split(bf);
      if (data[0][0] >= '0' && data[0][0] <= '9' && strlen(data[0])== 1) sprintf(schr, "0%s", data[0]);
      else strcpy(schr, data[0]);

      chr = atol(schr);
      pos = atol(data[1]);
      return 1;
    }

  pos = -1; //end of file
  return 0;
}


void CVCF :: Locate(int rchr, int rpos)
{
  char rschr[100];
  if (rchr < 10) sprintf(rschr, "0%d", rchr);
  else sprintf(rschr, "%d", rchr);
  Locate(rschr, rpos);
}

void CVCF :: Locate(char* rschr, int rpos)
{
  int seek = 0;
  if (strcmp(rschr, schr) != 0) seek = 1;
  
  if (seek)
    if (pos - pos < 1000000)  seek = 1;

  //  if (seek) TextFileSeek(f, rschr, rpos, 0);
  
  while (Compare(schr, pos, rschr, rpos) < 0)
    if (!ReadData()) break;
}

int CVCF :: GetData(int id)
{
  int n1 = 0;
  char *p = data[id + 9];
  if (p[0] == '1') n1  ++;
  if (p[2] == '1') n1  ++;
  return n1;
}


int CVCF :: GetConf(int id)
{
  return 10;
  int conf;
  char *p = data[id+9];

  char *p1 = strstr(p, ":");
  if (p1 == NULL) p1 = strstr(p, ".");


  if (p1 == NULL) 
    {
      printf("Error: %s\n", data[id]);
      exit(1);
    }
  p1++;
  //  p = strstr(p, ":") + 1;
  sscanf(p1, "%d", &conf);
  return conf;
}
