#include "Const.h"



int SplitInt(char* bf, int* pint)
{
  int nt = 0; 
  char *p = bf;
  while (p[0] != '\0')
    {
      while (p[0] != '\0' && (p[0] < '0' || p[0] > '9')) p++;
      if (p[0] == '\0') return nt;
      if (sscanf(p, "%d", &pint[nt]) == 1) nt ++;
      while (p[0] >= '0' && p[0] <= '9') p ++;
    }
  return nt;
}

//-------------------<chr,pos>----------------------
//     -1           ][   0   ][        1


int ComparePosition(int chr, int pos, int rchr, int rpos)
{
  //  printf("%d\t%d: %d %d\n", chr, pos, rchr, rpos);
  if (chr == rchr && pos == rpos) return 0;
  if (rchr < chr || (rchr == chr && rpos < pos)) return -1;
  return 1;
}

void TextFileSeek(FILE *f, int rchr, int rpos)
{
  char tempc[1024];
  sprintf(tempc, "%d", rchr);
  TextFileSeek(f, tempc, rpos, 1);
}


void TextFileSeek(FILE *f, char* rchr, int rpos)
{
  TextFileSeek(f, rchr, rpos, 1);
}


void TextFileSeek(FILE *f, int rchr, int rpos, int nl)
{
  char schr[100];
  if (rchr < 10) sprintf(schr, "0%d", rchr);
  else sprintf(schr, "%d", rchr);
  TextFileSeek(f, schr, rpos, nl);
}


//seek the location right before <rchr, rpos>
void TextFileSeek(FILE *f, char* rchr, int rpos, int nl)
{
  int pos;
  char schr[100];
  char *bf = (char*)calloc(K100, sizeof(char));

  long int fc = 0, bl = 1, fs;

  rewind (f);
  while (!feof(f))
    {
      fc =  ftell(f);
      fgets(bf, K100, f);
      if (bf[0] != '#') break;
    }

  fseek(f, 0, SEEK_END);
  fs = ftell(f);
  while (bl > 0)
    {
      if (fc + bl >= fs) bl /= 2;
      else
	{
	  fseek(f, fc + bl, SEEK_SET); //start
	  fgets(bf, K100, f); //read to the end of the current line
	  long int nfc = ftell(f);//read new data at nfc

	  fscanf(f, "%s %d", schr, &pos);
	  int t = strcmp(schr, rchr);

	  if (t > 1 || (t == 0 && pos >= rpos))  bl /= 2; //if jump over: (rchr, rpos) <= (chr, pos)
	  else  //move to new location and increase jump size by 2
	    { 
	      fc = nfc; 
	      bl *= 2;
	    }
	}
    }
  fseek(f, fc, SEEK_SET);
  free(bf);

  if (nl == 0) {
    fscanf(f, "%s %d", schr, &pos);
    TextFileSeek(f, schr, pos, nl+1);
  }
}



//seek the location right before <rchr, rpos>
int SeekBinaryFile(FILE *f, int BS, int rchr, int rpos)
{
  char bf[M1];
  char* chr = &bf[0]; 
  int*  pos = (int*)&bf[1];
  fseek (f , 0 , SEEK_END);

  long int fs = ftell(f);
  long int bl = BS, fc = 0;

  while (bl >= (unsigned int) BS)
    {
      if (fc + bl >= fs) { bl /= 2; continue;}
      fseek(f, fc + bl, SEEK_SET);

      if (fread(bf, 1, BS, f) != (size_t)BS) { bl /= 2; continue;}

      if (chr[0] > rchr || (chr[0] == rchr && pos[0] >= rpos)) bl /= 2;
      else 
	{
	  fc = fc + bl;
	  bl *= 2;
	}
    }
  fseek(f, fc, SEEK_SET);
  return 1;
}





void Free(char** s, int ns)
{
  for (int i =0; i != ns; ++i) free(s[i]);
  free(s);
}


char** Calloc(int ns, int m)
{
  char ** out = (char**) calloc(ns, sizeof(char*));

  if (out == NULL)
    {
      printf("error in calloc out\n");
      exit(1);
    }

  for (int i =0; i != ns;  ++i)
    out[i] = (char*) calloc(m + 10, sizeof(char));


  for (int i = 0; i != ns; ++i)
    for (int j = 0; j != m; ++j) out[i][j] = '.';

  for (int i =0; i != ns; ++i) out[i][m] = '\0';

  return out;
}

/*

int MaxID(double *p, int ns)
{
  int id = 0;
  for (int i = 0; i != ns;  ++i)
    if (p[i] > p[id]) id = i;

  return id;
}
*/


void Norm(double *p, int ns)
{
  double sum = 0;
  for (int i = 0; i != ns; ++i) sum += p[i];

  if (sum != 0)
    for (int i = 0; i != ns; ++i) p[i] /= sum;
}


void Norm(double *p)
{
  Norm(p, NG);
}

/*
int MAX (int x, int y)
{
  if (x > y) return x; 
  else return y;
}

int MIN (int x, int y)
{
  if (x < y) return x; 
  else return y;
}

*/
void View(char *s)
{
  int len = strlen(s);
  for (int i = 0; i != len; ++i)
    if (s[i] < '2') printf("%c", s[i]);
    else
      if (s[i] == '2') printf("-");
      else printf(".");
  printf("\n");

}

void Match(char **alnnames, int nsp, char **lknames, int nslk, int *index)
{
  for (int i = 0; i != nsp; ++i) index[i] = -1;

  for (int i = 0; i != nsp; ++i)
    for (int j = 0; j != nslk; ++j)
      if (strstr(lknames[j], alnnames[i]) != NULL) {
	index[i] = j; //find the index for sample ith in ARG Tree

	//	printf("%s\t%s: %d %d\n", lknames[j], alnnames[i], i, j);
      }
}


double ** CallocDouble(int n, int m)
{
  double ** out = (double**)calloc(n, sizeof(double*));
  for (int i =0; i != n; ++i) out[i] = (double*)calloc(m, sizeof(double));
  return out;
}


void FreeDouble(double **p, int n)
{
  for (int i =0; i != n; ++i) free(p[i]);
  free(p);
  p = NULL;
}


int VertChr(char *chrc)
{
  char *p = chrc;
  while (p[0] == ' ' || p[0] == '\t') p++;

  if (p[0] == 'X') return 23;
  if (p[0] == 'Y') return 24;
  if (p[0] == 'M' && p[1] == 'T') return 25;
  
  int chr = 100;
  if (sscanf(p, "%d", &chr) != 1) return -1;
  return chr;
}



double EXP(double x)
{
  if (x < -300) return 0;
  if (x > 300) return exp(300);
  return exp(x);
}


void DisplayChar(char **s, int n)
{
  for (int i = 0; i !=  n; ++i)
    printf("%s\n", s[i]);
  printf("\n");

}


void DisplayVectDouble(double *p, int n)
{
  for (int i =0; i != n; ++i) printf("%f\t", p[i]);
  printf("\n");
}


void DisplayMatrixDouble(double *p, int n, int m)
{
  for (int i =0; i != n; ++i) DisplayVectDouble(&p[i*m], m);
  printf("\n");
}



int MaxProb(double *p, int n)
{
  int mi = 0;
  for (int i = 0; i != n; ++i)
    if (p[i] > p[mi]) mi = i;
  return mi;
}


/*

int *Revert(int *ind, int n)
{
  int mn = ind[0];
  for (int i = 0; i != n; ++i) 
    if (mn < n) n = mn;

  int *out = (int*)calloc(nm, sizeof(int));
  for (int i = 0; i != nm; ++i) out[i] = -1;

  for (int i = 0; i != n; ++i) out[ ind[i]] = i;


}
*/


int CHR(char *s)
{
  if (strstr(s, "X") != NULL) return 23;
  if (strstr(s, "Y") != NULL) return 24;
  if (strstr(s, "MT") != NULL) return 25;
  return atol(s);

}





int ReadChrPos(FILE *f, char *s, int &pos)
{
  char tempc[100];

  if (fscanf(f, "%s %d", tempc, &pos) != 2) return 0;
  
  if (tempc[0] >= '1' && tempc[0] <= '9' && strlen(tempc) == 1) //0->9 --> 00 -- 99
    sprintf(s, "0%s", tempc);
  else 
    strcpy(s, tempc);
  return 1;
}


int Compare(char *s1, int p1, char *s2, int p2)
{
  int t = strcmp(s1, s2);
  if (t  != 0) return  t;

  if (p1 > p2) return 1;
  if (p1 < p2) return -1;

  return 0;
}



int Prob2Phred(double x)
{
  if (x == 0) return 100;
  double const log10 = 2.302585092994050000000;
  double p = -10 * log(x)  / log10;
  int t = int (p);
  if (t > 100) t = 100;
  return t;
}

void CleanBF(char *bf)
{
  int i = strlen(bf) -1;
  while (i >= 0 && bf[i] < 33) i--;
  int len = i + 1;
  bf[len] = '\0';


  int l = 0;
  
  for (int i =0; i != len; ++i) 
    if (bf[i] < 33) bf[i] = '\t';

  for (int i =0; i != len; ++i)
    {
      if (bf[i] != '\t') bf[l++] = bf[i];
      else
	if (i > 0) 
	  if (bf[i-1] != '\t') bf[l++] = bf[i];
    }
  bf[l] = '\0';
}


void Display(double *p, int ns)
{
  for (int i = 0; i != ns; ++i) printf("%f\t", p[i]);
  printf("\n");
}


int *GetIndex(char *s, char ref)
{
  char DNA[] = "ACGT";

  int *out = (int*)calloc(255, sizeof(int));
  for (int i = 0; i != 255; ++i) out[i] = '0';

  int nc = 1;
  for (int i = 0; i != NA; ++i)
    if (DNA[i] != ref)
      if (strchr(s, DNA[i]) != NULL) { out[ DNA [i] ] = nc + 48; nc ++;}

  return out;
}


char** Split(char *bf, int &nf)
{

  int l = strlen(bf)-1;
  while (l > 0 && bf[l] <= 32)  l--;
  bf[l+1] = '\0';

  char ** out = (char**)calloc(K1, sizeof(char*));
  char *p = bf;
  nf = 0;
  while (p[0] != '\0')
    {
      while (p[0] == ' ' || p[0] == '\t') p++; //skip ' ' and '\t'    
      if (p[0] == '\0') break;
      if (p[0] == 10 || p[0] == 13) { p++; continue;}

      out[nf++] = p;
      while (p[0] != ' ' && p[0] != '\t' && p[0] != '\0') p++;
      if (p[0] == '\0') break;
      p[0] = '\0'; 
      p++;
    }
  return out;
}




char * Clone(char *s)
{
  if (s == NULL) return NULL;
  char *out = (char*)calloc(strlen(s) + 10, sizeof(char));
  strcpy(out, s);
  return out;
  
}

char * CloneScan(char *s)
{
  if (s == NULL) return NULL;
  char *out = (char*)calloc(strlen(s) + 10, sizeof(char));
  sscanf(s, "%s", out);
  return out;
}


int  GetChrPos(FILE *f, int &chr, int &pos)
{
  if (fscanf(f, "%d %d", &chr, &pos) != 2) return 0; //no more data
  //scan for end of line
  char ch = ' ';
  while (ch != 10 && !feof(f)) ch = fgetc(f);
  return 1;
}



int fetch_func(int l, const char *s, void *data)
{
  //  printf("coming here\n");
  //  printf("s = %s\n", s);



  buffer_t *buf = (buffer_t*) data;

  if (buf->ntree == buf->maxtree)
    {
      buf->maxtree += K1;
      buf->data = (char**)realloc(buf->data, buf->maxtree * sizeof(char*));
      //      for (int i = buf->ntree; i != buf->maxtree; ++i) buf->data[i] = NULL; 
    }

  /*

  
  while ( len+buf->pos+2 > buf->size )
    {
      //      fprintf(stderr,"The buffer is too small, ignoring line: %s\n", s);

      buf->size += M1;
      buf->data = (char*)realloc(buf->data,  buf->size * sizeof(char));
      if (buf->data == NULL) //error in reallloc 
	{
	  printf("memory realloc error:  realloc data for buf->data;\n");
	  exit(1);
	}
    }
  */
  int len = strlen(s);
  buf->data[buf->ntree] = (char*)calloc(len + 10, sizeof(char));
  strcpy(buf->data[buf->ntree++], s);
  /*

  memcpy(buf->data+buf->pos,s,len);
  buf->pos += len+1;
  buf->data[buf->pos-1] = '\n';
  buf->data[buf->pos]   = 0;
  */
  return 0;
}


