#ifndef __CONST__
#define __CONST__
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#ifndef EOF
#define EOF 1000
#endif


#ifndef NEWSITE
#define NEWSITE 2
#endif

#ifndef OK
#define OK 1
#endif

#ifndef DISPLAY
#define DISPLAY 0
#endif

#ifndef MAXSTEP
#define MAXSTEP 100000
#endif

#ifndef K10
#define K10 10000
#endif

#ifndef M1
#define M1 1000000
#endif

#ifndef NG
#define NG 10
#endif


#ifndef BINARY
#define BINARY 1
#endif


#ifndef TEXT
#define TEXT 0
#endif


#ifndef NA 
#define NA 4
#endif


#ifndef NA2
#define NA2 16
#endif

#ifndef Q_BINARY
#define Q_BINARY 2
#endif


#ifndef MAX_EXP10
#define MAX_EXP10 10
#endif


#ifndef Q_BIN_BLOCKSIZE
#define Q_BIN_BLOCKSIZE sizeof(char) + sizeof(int) + 10
#endif

#ifndef M1
#define M1 1000000
#endif

#ifndef K1
#define K1 1000
#endif


#ifndef K10
#define K10 10000
#endif


#ifndef K100
#define K100 100000
#endif

#ifndef MAXSAMPLE
#define MAXSAMPLE 5000 //2500
#endif


#ifndef MINCONF
#define MINCONF .9
#endif


#ifndef MIN_THRESHOLD
#define MIN_THRESHOLD -10
#endif



#ifndef DEBUG
#define DEBUG 0
#endif


#ifndef THETA
#define THETA 0.001
#endif


#ifndef SNPCAN
#define SNPCAN_TH .99
#endif



#ifndef SNPCAN_ARG
#define SNPCAN_ARG_TH .99
#endif


int SplitInt(char *bf, int* pint); 

//seek text file
void TextFileSeek(FILE *f, int rchr, int rpos);
void TextFileSeek(FILE *f, int rchr, int rpos, int nl);
void TextFileSeek(FILE *f, char *chr, int pos);
void TextFileSeek(FILE *f, char *chr, int pos, int nl);




typedef struct
{
  char **data;
  int  ntree;
  int  maxtree;
} buffer_t;



//#define MIN(a, b)  
#define MIN( a, b )  ( a<b )? a : b
#define MIN3( a, b, c) MIN( (MIN ( (a), (b))), (c))
#define MAX(a,b)  (a>b)? a:b
#define MAX3( a, b, c) MAX ( ( MAX ( (a), (b))), (c))


#define LOC(sid, gid) (sid*NG + gid)





//-------------------<chr,pos>----------------------
//     -1           ][   0   ][        1
int ComparePosition(int chr, int pos, int rchr, int rpos);

int SeekBinaryFile(FILE *f, int BS, int rchr, int rpos);


void Free(char** s, int ns);
char ** Calloc(int ns, int m);

void Norm(double *p, int ns);
void Norm(double *p);


//int MAX(int x, int y);
//int MIN(int x, int y);
void View(char *s);

void Match(char **allnames, int nsp, char** lknames, int nslk, int *index);


double **CallocDouble(int n, int m);
void FreeDouble(double **p, int n);

int VertChr(char *s);

double EXP(double x);


void DisplayChar(char** s, int n);

void DisplayVectDouble(double *p, int n);

void DisplayMatrixDouble(double *p, int n, int m);

int MaxProb(double *p, int n);


int CHR(char *s);


int ReadChrPos(FILE *f, char *s, int &pos);
int Compare(char *s1, int p1, char *s2, int p2);
int Prob2Phred(double x);


void CleanBF(char *bf);


void Display(double *p, int ns);

int *GetIndex(char *s, char ref);

char** Split(char *bf, int &nf);





char *Clone(char*);
char *CloneScan(char*);

//int *Revert(int *ind, int n);

int GetChrPos(FILE *f, int &chr, int &pos);

int fetch_func(int l, const char *s, void *data);



#endif




