//#include "../Common/Const.h"
//#include "Prob4.h"
//#include "bin.cpp"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "Const.h"
#include "COneSiteLK.h"

#ifndef __SNP__
#define __SNP__

#ifndef NA
#define NA 4
#endif

#ifndef NG
#define NG 10
#endif


class CSNP{
 private:

  //  CRead ref;

  double *pp; //pp[n][i] = 
  double *bf1, *bf2;

  double theta;
  int order[NA][NA];

  char DNA[10];

  int maxn;
  long Count[NA];

  double ProbGen(long i, int h1, int h2);

  int n;
  //  int MajorAllele(char **B);

  double Computing(int h1, int h2);
  int OrderDNA[K1];

  double Phred2Prob[K1];


  //PPHet[n] = 1/6 * theta/2 * (sum_{i=1}^{2n-1} (1/i + 1/(2n-i))) if discrete
  //PPHom[n] = 1/4 (1 - 6 * PPHet[n])
  double *PPHom;
  double *PPHet;

  //  pphet[n][i] =  (1/i + 1/(2n-i)) / sum_j(1/j + 1/(2n-j))
  double **pphet;
  //  W[n] = (2n-1) / (sum_{i=1}^{2n-1} (1/q_i  + 1 /(1-q_i))  where q_i = 1/2n if discrete
  //  W[n] = theta /  (4n*0.01)
  double *W;
  //  long Z[MaxN][MaxN]; //Z[n][k]: # possible divide 2n into k allele a, 2n-a,
  double **Z;

  double threshold;

 public:
  CSNP();
  ~CSNP();

  double* SNP(double *prob, int ni);
  double* SNP(double *prob, int ni, int rid);

  double  SNPConfidence (double *prob, int ni, int rid);
  void    SNPConfidence (double *prob, int ns, int &rid, double &conf, char &altall, double &maf);

  void GetSNPConfidence(COneSiteLK *os, double &conf, char &alt, double &maf);

  /*
  double  SNPConfidence(double *prob, int ni)    {  return     SNPConfidence(prob, ni, -1);    }
  */

  void Init(int maxN);
  void Init(void);

  void Norm(double *p);
  void Norm(double *p, int n);

  double GetThreshold(void){ return threshold;}
  void  SetThreshold(double sthreshold){ threshold = sthreshold;}
};


#endif
